#
#	Machine Description
#
# ARCH = AMD64

#
#  Specify LoadLeveler Administrators here:
#
LOADL_ADMIN = loadl	

#
#	Default to starting LoadLeveler daemons when requested
#
START_DAEMONS = TRUE

#
#	Machine authentication
#
#	If TRUE, only connections from machines in the ADMIN_LIST are accepted.
#	If FALSE, connections from any machine are accepted.  Default if not
#	specified is FALSE.
#
MACHINE_AUTHENTICATE = FALSE

#
# Specify central and resource managers and their back ups.
#       The first machine listed is the central or resource manager and
#       any additional machines are alternate managers.
#
# CENTRAL_MANAGER_LIST = Mach1 Mach2
# RESOURCE_MGR_LIST = Mach1 Mach2

#
# Specify information for backup central and resource managers
#
# FAILOVER_HEARTBEAT_INTERVAL = 300
# FAILOVER_HEARTBEAT_RETRIES = 6

#
# Specify pathnames
#
# RELEASEDIR contains the directory path to where the loadl binaries are
#
RELEASEDIR      = /opt/ibmll/LoadL/full
ADMIN_FILE      = /opt/ibmll/LoadL/scheduler/full/samples/LoadL_admin.l
LOG	        = /var/loadl/log
SPOOL	        = /var/loadl/spool
EXECUTE		= /var/loadl/execute
HISTORY		= $(SPOOL)/history
RESERVATION_HISTORY = $(SPOOL)/reservation_history
BIN		= $(RELEASEDIR)/bin

#
# Specify port numbers
#
NEGOTIATOR_STREAM_PORT = 9614
MASTER_STREAM_PORT     = 9616
REGION_MGR_STREAM_PORT = 9680
RESOURCE_MGR_STREAM_PORT = 9618
SCHEDD_STREAM_PORT     = 9605
STARTD_STREAM_PORT     = 9611

COLLECTOR_DGRAM_PORT   = 9613
STARTD_DGRAM_PORT      = 9615
MASTER_DGRAM_PORT      = 9617
REGION_MGR_DGRAM_PORT  = 9682
RESOURCE_MGR_DGRAM_PORT = 9619


#
# Specify a scheduler type:  LL_DEFAULT, API, BACKFILL
#   API specifies that internal LoadLeveler scheduling algorithms be
#   turned off and LL_DEFAULT specifies that the original internal 
#   LoadLeveler scheduling algorithm be used.
#
SCHEDULER_TYPE = BACKFILL

#
# Specify accounting controls
# To turn reservation data recording on, add the flag A_RES to ACCT
#
ACCT 			= A_OFF A_RES
#ACCT_VALIDATION	= $(BIN)/llacctval
GLOBAL_HISTORY		= $(SPOOL)

#
# Specify prolog and epilog path names
#
# JOB_PROLOG = 
# JOB_EPILOG = 
# JOB_USER_PROLOG = 
# JOB_USER_EPILOG =

#
# Refresh AFS token program.
# 
# AFS_GETNEWTOKEN = 

#
# Customized mail delivery program.
# 
# MAIL = 

#
# Customized submit (job command file) filter program.
# 
# SUBMIT_FILTER = 

#
# Specify checkpointing intervals
#
# MIN_CKPT_INTERVAL    = 900
# MAX_CKPT_INTERVAL    = 7200

# perform cleanup of checkpoint files once a day            
# 24 hrs x 60 min/hr x 60 sec/min = 86400 sec/day
 
# CKPT_CLEANUP_INTERVAL = 86400


# sample source for the ckpt file cleanup program is shipped with LoadLeveler
# and is found in:  /opt/ibmll/LoadL/scheduler/full/samples/llckpt/rmckptfiles.c
#
# compile the source and indicate the location of the executable 
# as shown in the following example

# CKPT_CLEANUP_PROGRAM = /u/mylladmin/bin/rmckptfiles

#	LoadL_KeyboardD Macros
#
KBDD                = $(BIN)/LoadL_kbdd
KBDD_LOG            = $(LOG)/KbdLog
MAX_KBDD_LOG        = 64000
#KBDD_DEBUG          =

# 
# Specify whether to start the keyboard daemon
#
X_RUNS_HERE			= False

#
#		LoadL_StartD Macros
#
STARTD			   = $(BIN)/LoadL_startd
STARTD_LOG		   = $(LOG)/StartLog
MAX_STARTD_LOG	 	   = 64000
#STARTD_DEBUG		   =
POLLING_FREQUENCY	   = 5
POLLS_PER_UPDATE	   = 24
JOB_LIMIT_POLICY	   = 120
JOB_ACCT_Q_POLICY 	   = 300
PROCESS_TRACKING	   = FALSE
#PROCESS_TRACKING_EXTENSION = $(BIN)

#DRAIN_ON_SWITCH_TABLE_ERROR = false
#RESUME_ON_SWITCH_TABLE_ERROR_CLEAR = false


#
#		LoadL_SchedD Macros
#
SCHEDD			= $(BIN)/LoadL_schedd
SCHEDD_LOG		= $(LOG)/SchedLog
MAX_SCHEDD_LOG		= 64000
#SCHEDD_DEBUG		=
SCHEDD_INTERVAL		= 120

CLIENT_TIMEOUT		= 30

MACHINE_UPDATE_INTERVAL = 300

#
# Negotiator Macros
#
NEGOTIATOR			= $(BIN)/LoadL_negotiator
#NEGOTIATOR_DEBUG		=
NEGOTIATOR_LOG			= $(LOG)/NegotiatorLog
MAX_NEGOTIATOR_LOG		= 64000
NEGOTIATOR_INTERVAL		= 60
NEGOTIATOR_PARALLEL_DEFER	= 300
NEGOTIATOR_PARALLEL_HOLD	= 300
NEGOTIATOR_RESCAN_QUEUE		= 90
NEGOTIATOR_REMOVE_COMPLETED	= 0
NEGOTIATOR_CYCLE_DELAY          = 0
NEGOTIATOR_CYCLE_TIME_LIMIT     = 0

#
#	Resource Manager Macros
#
RESOURCE_MGR		        = $(BIN)/LoadL_resource_mgr
#RESOURCE_MGR_DEBUG		=
RESOURCE_MGR_LOG		= $(LOG)/ResourceManagerLog
MAX_RESOURCE_MGR_LOG	        = 64000
RESOURCE_MGR_COREDUMP_DIR 	= /tmp

#
# Sets the interval between recalculation of the SYSPRIO values
# for all the jobs in the queue
#
NEGOTIATOR_RECALCULATE_SYSPRIO_INTERVAL = 0

#
# Consumable Resources
#
# SCHEDULE_BY_RESOURCES = ConsumableCpus LicenseA FloatingLicenseX

# WLM can be used to enforce resource usage for ConsumableCpus and/or
# for ConsumableMemory
#
# or by specifying deactivate, WLM will be deactivated on all nodes in the
# LoadLeveler cluster
# ENFORCE_RESOURCE_USAGE = ConsumableCpus

# the default is false for ENFORCE_RESOURCE_SUBMISSION which means
# allow jobs to be scheduled that do not request any resources
#
# by setting this to true, all jobs must request resources to be scheduled
# ENFORCE_RESOURCE_SUBMISSION = true

# When ENFORCE_RESOURCE_USAGE is set, the way enforcement is done is specified
# using ENFORCE_RESOURCE_POLICY.  The policies available are hard, soft,
# and shares.
# ENFORCE_RESOURCE_POLICY = shares

# FLOATING_RESOURCES = FloatingLicenseX(5) FloatingLicenseZ(2)

#
# Starter Macros
#
STARTER			= $(BIN)/LoadL_starter
#STARTER_DEBUG		= 
STARTER_LOG             = $(LOG)/StarterLog
MAX_STARTER_LOG         = 64000

#
# LoadL_Master Macros
#
MASTER			= $(BIN)/LoadL_master
MASTER_LOG		= $(LOG)/MasterLog
#MASTER_DEBUG		=
MAX_MASTER_LOG		= 64000
RESTARTS_PER_HOUR	= 12
PUBLISH_OBITUARIES	= TRUE
OBITUARY_LOG_LENGTH	= 25

#
#   Region Manager Macros
#
#REGION_MGR        = $(BIN)/LoadL_region_mgr
#REGION_MGR_DEBUG      = D_REGIONMGR
#REGION_MGR_LOG        = $(LOG)/RegionMgrLog
#MAX_REGION_MGR_LOG    = 64000
#REGION_MGR_COREDUMP_DIR   = /tmp

# Specify settings for the heartbeat between the region manager and the startd
#
#ADAPTER_HEARTBEAT_INTERVAL = 30
#ADAPTER_HEARTBEAT_RETRIES = 2
#ADAPTER_HEARTBEAT_PORT = 9684

#
# Specify whether log files are truncated when opened
#
TRUNC_NEGOTIATOR_LOG_ON_OPEN = False

TRUNC_MASTER_LOG_ON_OPEN     = False
TRUNC_STARTD_LOG_ON_OPEN     = False
TRUNC_SCHEDD_LOG_ON_OPEN     = False
TRUNC_KBDD_LOG_ON_OPEN       = False
TRUNC_STARTER_LOG_ON_OPEN    = False
TRUNC_REGION_MGR_LOG_ON_OPEN = False
TRUNC_RESOURCE_MGR_LOG_ON_OPEN = False

#
# Specify Machine's relative priority to run jobs.
#
# CUSTOM_METRIC		=
# CUSTOM_METRIC_COMMAND	= 

#
# Multicluster keywords
#
# Sample source for the multicluster installation exits are shipped 
# with LoadLeveler and can be found in:  
# /opt/ibmll/LoadL/scheduler/full/samples/llcluster
#
# indicate the location of the installation exit to be used by
# the Schedd daemon to determine the cluster to which 
# a remote job is distributed.
# 
# CLUSTER_METRIC=/opt/ibmll/LoadL/scheduler/full/samples/llcluster/cluster_metric_free_nodes
#
# indicate the location of the installation exit to be used by
# the Schedd daemon to determine the user mapping of the local cluster
# for arriving remote jobs and commands.
# 
#CLUSTER_USER_MAPPER=/opt/ibmll/LoadL/scheduler/full/samples/llcluster/cluster_user_mapper
#
# indicate the location of the installation exit to be used by
# the Schedd daemon to send job object updates back to the Schedd
# for arriving remote jobs.
# 
#CLUSTER_REMOTE_JOB_FILTER=/opt/ibmll/LoadL/scheduler/full/samples/llcluster/cluster_job_filter

#
#	Expressions used to control starting and stopping of foreign jobs
#
MINUTE		= 60
HOUR		= (60 * $(MINUTE))
StateTimer	= (CurrentTime - EnteredCurrentState)

BackgroundLoad		= 0.7
HighLoad		= 1.5
StartIdleTime		= 15 * $(MINUTE)
ContinueIdleTime	= 5 * $(MINUTE)
MaxSuspendTime		= 10 * $(MINUTE)
MaxVacateTime		= 10 * $(MINUTE)

KeyboardBusy	= KeyboardIdle < $(POLLING_FREQUENCY)
CPU_Idle	= LoadAvg <= $(BackgroundLoad)
CPU_Busy	= LoadAvg >= $(HighLoad)

#
#  See Using and Administering LoadLeveler for an explanation of these 
#  control expressions
#
# START		: $(CPU_Idle) && KeyboardIdle > $(StartIdleTime)
# SUSPEND	: $(CPU_Busy) || $(KeyboardBusy)
# CONTINUE	: $(CPU_Idle) && KeyboardIdle > $(ContinueIdleTime)
# VACATE	: $(StateTimer) > $(MaxSuspendTime)
# KILL		: $(StateTimer) > $(MaxVacateTime)

START		: T
SUSPEND		: F
CONTINUE	: T
VACATE		: F
KILL		: F

#
#	Expressions used to prioritize job queue
#
#	Values which can be part of the SYSPRIO expression are:
#
#	QDate		  Job submission time
#	UserPrio	  User priority
#	UserSysprio	  System priority value based on userid (from the user
#			  list file with default of 0)
#	ClassSysprio	  System priority value based on job class (from the 
#			  class list file with default of 0)
#	GroupSysprio      System priority value based on the group (from the
#			  group list file with default of 0)
#	GroupQueuedJobs   Number of job steps running or queued for the group
#	GroupRunningJobs  Number of job steps running for the group
#	GroupTotalJobs    Total number of job steps for the group
#	UserQueuedJobs    Number of job steps running or queued for the user
#	UserRunningJobs   Number of job steps running for the user
#	UserTotalJobs     Total number of job steps for the user
#
#	The following expression is an example.
#
#SYSPRIO: (ClassSysprio * 100) + (UserSysprio * 10) + (GroupSysprio * 1)- (QDate)
#
#	The following (default) expression for SYSPRIO creates a FIFO job queue.
#
SYSPRIO: 0 - (QDate)

#
#	Expressions used to prioritize machines
#
#	The following example orders machines by the load average
#	normalized for machine speed:
#
#MACHPRIO: 0 - (1000 * (LoadAvg / (Cpus * Speed)))
#
#	The following (default) expression for MACHPRIO orders
#	machines by load average.
#
MACHPRIO: 0 - (LoadAvg)
#
# The MAX_JOB_REJECT value determines how many times a job can be 
#	rejected before it is canceled or put on hold.  The default value
#	is 0, which indicates a rejected job will immediately be canceled
#	or placed on hold. MAX_JOB_REJECT may be set to unlimited rejects
#	by specifying a value of -1.
#
MAX_JOB_REJECT = 0
#
# When ACTION_ON_MAX_REJECT is HOLD, jobs will be put on user hold
#	when the number of rejects reaches the MAX_JOB_REJECT value.  When
#	ACTION_ON_MAX_REJECT is CANCEL, jobs will be canceled when the
#	number of rejects reaches the MAX_JOB_REJECT value. The default
#	value is HOLD.
#
ACTION_ON_MAX_REJECT = HOLD
#
# The REJECT_ON_RESTRICTED_LOGIN specifies if the user's AIX login status 
#	should be checked to determine if the user is locked out. 
#	REJECT_ON_RESTRICTED_LOGIN may only be specified in the global 
#	configuration file. Valid values are TRUE or FALSE.  FALSE is the 
#	default which indicates that no AIX login restriction check is to be 
#	performed. TRUE specifies that the AIX login restriction check is to be 
#	performed on every node the job is scheduled to run on. If the user 
#	has been locked out on any of these nodes then the job will be rejected. 
#
REJECT_ON_RESTRICTED_LOGIN = FALSE

#
# To specify the security method used, set SEC_ENABLEMENT to COMPAT, DCE,
# or CTSEC. The default security method is COMPAT. When SEC_ENABLEMENT=CTSEC
# or SEC_ENABLEMENT=DCE the SEC_ADMIN_GROUP and the SEC_SERVICES_GROUP must
# also be specified. See Using and Admin Guide for a description of setting
# these keywords when DCE or CTSEC are enabled.
# 
#SEC_ENABLEMENT=CTSEC
#SEC_ADMIN_GROUP=LoadL-admin
#SEC_SERVICES_GROUP=LoadL-services
#
# When SEC_ENABLEMENT=CTSEC, you can specify SEC_IMPOSED_MECHS.
# SEC_IMPOSED_MECHS identifies the security mechanism which may be used
# by LoadLeveler for authentication. This should be used if LoadLeveler is
# restricted to using a subset of authentication methods for which machines 
# in your cluster are configured.  The mechanisms available to LoadLeveler
# are none and unix.
# none indicates users can run unauthenticated, although if authorization
# is required this will fail.
# unix indicates that Unix host-based authentication can be used.
#
#SEC_IMPOSED_MECHS=none unix
#
# The default DCE_AUTHENTICATION_PAIR used when SEC_ENABLEMENT is
# specified as DCE is shown below.  If you wish to use the default
# you may leave DCE_AUTHENTICATION_PAIR commented out, or uncomment
# the following line.
#
#DCE_AUTHENTICATION_PAIR = $(BIN)/lldelegate, $(BIN)/llimpersonate
#
# To enable LoadLeveler to support DCE security credential passing 
# when SEC_ENABLEMENT is not set to DCE, uncomment the following 
# keyword. You may also choose to uncomment the following line when
# DCE_ENABLEMENT is specified as DCE to overrride the default
# DCE_AUTHENTICATION_PAIR.
# 
# An installation can provide its own executables to pass or establish DCE
# security credentials for a LoadLeveler job by replacing the executables 
# specified by DCE_AUTHENTICATION_PAIR.
#
#DCE_AUTHENTICATION_PAIR = $(BIN)/llgetdce, $(BIN)/llsetdce
#

# Algorithm a used by the negotiator to determine if a machine has enough
# virtual memory to satisfy the image_size requirement of a job step
#
# can either be FREE_PAGING_SPACE which is the default
# or FREE_PAGING_SPACE_PLUS_FREE_REAL_MEMORY

# VM_IMAGE_ALGORITHM = FREE_PAGING_SPACE

# Filesystem Monitor Interval and Threshholds 

# Monitoring Interval is in minutes and should be set according to how
# Fast the filesystem grows
# FS_INTERVAL = 30

# Threshholds are specified in low,high pairs.  When the value being
# monitored goes below the low value, the action is taken (eg. the
# administrator is notified of a problem or LoadLeveler is suspended or
# terminated).  When the value being monitored rises above the high
# threshhold after being below the low threshhold, the complementary
# action is taken -- the administrator is notified that the problem
# has been resolved or LoadLeveler is resumed.  LoadLeveler is not
# restarted if it is terminated because the 'Terminate' action
# was taken.

# File System space threshholds are specified in Bytes.  Scaling factors
# such as K, M and G are allowed.
# FS_NOTIFY       = 750KB,1MB
# FS_SUSPEND      = 500KB, 750KB
# FS_TERMINATE    = 100MB,100MB

# File System inode threshholds are specified in number of inodes.  Scaling factors
# such as K, M and G are allowed.
# INODE_NOTIFY    = 1K,1.1K
# INODE_SUSPEND   = 500,750
# INODE_TERMINATE = 50,50

#PREEMPT_CLASS[large] = ALL{medium} ENOUGH{small}

#START_CLASS[medium] = (small<20)
#START_CLASS[large] = (small<10)

#
#	Expressions used to control Advance Reservation
#
#	When RESERVATION_CAN_BE_EXCEEDED = TRUE job steps whose end times
#	(based on hard wall clock limit) exceed the reservation end time
#	will be scheduled to run.
#
#RESERVATION_CAN_BE_EXCEEDED = TRUE
#
#	Specify the maximum number of reservations not in the CANCEL or
#	COMPLETE states which a LoadLeveler cluster can have.
#
#MAX_RESERVATIONS = 10
#
#	The minimum time in advance, in minutes that a reservation has to
#	be created before its start time.
#
#RESERVATION_MIN_ADVANCE_TIME = 1440
#
#	The amount of time, in seconds, that will be used right before
#	the start time of a reservation to setup the reservation.
#
#RESERVATION_SETUP_TIME = 60
#
#	The priority of reservations at creation time relative to job steps.
#	A value of HIGH indicates that LoadLeveler administrators can make
#	reservations cutting through preemptable job step's expected running
#	time. This keyword is only applicable to LoadLeveler administrators.
#	Reservations made by non-administrators will not have a higher
#	priority than job steps.
#
#RESERVATION_PRIORITY = NONE
#

#
#	Setup for Fair Share Scheduling - Start
#
# By default, Fair Share Scheduling is turned off. 
# FAIR_SHARE_TOTAL_SHARES=0 
#
# Fair Share Scheduling is turned on if the keyword value is > 0.
# The larger the value, the easier the number of used shares will change.
# FAIR_SHARE_TOTAL_SHARES=1000 
#
# Resource usage collected within the most recent time period of this length
# matters the most to Fair Share Scheduling.
# By default, 168 hours (1 week) is the interval of significant influence.
# FAIR_SHARE_INTERVAL=168
#
# The interval should be much longer than the typical job running time
# in the LoadLeveler cluster. The interval can be a year, for example.
# FAIR_SHARE_INTERVAL=8760
#
# The SYSPRIO expression must be used to specify the behavior of 
# Fair Share Scheduling, i.e., how share usage will influence job priority.
# In addtion to the values listed earlier in this file, the following can be 
# part of the SYSPRIO expression as well to make use of Fair Share Scheduling:
# UserTotalShares    The total number of shares allocated to the user
# UserUsedShares     The number of CPU shares used by the user
# UserUsedBgShares   The number of Blue Gene shares used by the user
# GroupTotalShares   The total number of shares allocated to the group
# GroupUsedShares    The number of CPU shares used by the group
# GroupUsedBgShares  The number of Blue Gene shares used by the group
# JobIsBlueGene      The job step is a Blue Gene step or not
# 
# The following user variables can be defined in this file for convenience:
# UserRemainingShares = (UserTotalShares - UserUsedShares)
# UserHasShares = ($(UserRemainingShares) > 0)
# UserSharesExceeded = ($(UserRemainingShares) <= 0)
# GroupRemainingShares = (GroupTotalShares - GroupUsedShares)
# GroupHasShares = ($(GroupRemainingShares) > 0)
# GroupSharesExceeded = ($(GroupRemainingShares) <= 0)
# 
# Some examples of the SYSPRIO expression for Fair Share Scheduling:
#
# The jobs whose groups have unused shares have much higher priority.
# SYSPRIO: 10000000 * $(GroupHasShares) - QDate
#
# The jobs whose owners have the highest number of unused shares have the 
# highest priority. The more the number of the allocated shares are exceeded, 
# the lower is the job priority for the user.
# SYSPRIO: 100000 * $(UserRemainingShares)
#
# A job whose owner and group both have unused shares have the highest priority.
# SYSPRIO: 10000000 * ($(GroupHasShares)+$(UserHasShares))
#
# 
# If BG_ENABLED = True for a cluster with a Blue Gene system,
# the following user variables can be defined in this file for convenience:
# UserRemainingBgShares = ( UserTotalShares - UserUsedBgShares )
# UserHasBgShares = ( $(UserRemainingBgShares) > 0 )
# UserBgSharesExceeded = ( $(UserRemainingBgShares) <= 0 )
# GroupRemainingBgShares = ( GroupTotalShares - GroupUsedBgShares )
# GroupHasBgShares = ( $(GroupRemainingBgShares) > 0 )
# GroupBgSharesExceeded = ( $(GroupRemainingBgShares) <= 0 )
# JobIsNotBlueGene = (! JobIsBlueGene)
# 
# Some examples of the SYSPRIO expression for Fair Share Scheduling
# when BG_ENABLED = True:
#
# The jobs whose groups have unused Blue Gene shares have much higher priority.
# SYSPRIO: 10000000 * $(GroupHasBgShares) - QDate
#
# The jobs whose owners have the highest number of unused shares have the 
# highest priority. The more the number of the allocated shares are exceeded, 
# the lower is the job priority for the user. Treat the Blue Gene jobs and 
# non-BG jobs separately.
# SYSPRIO: 1000 * $(UserRemainingShares) * $(JobIsNotBlueGene) + 100000 * $(UserRemainingBgShares) * JobIsBlueGene
#
# A Blue Gene job whose owner and group both have unused Blue Gene shares have
# the highest priority.
# SYSPRIO: 10000000 * ($(GroupHasBgShares)+$(UserHasBgShares)) * JobIsBlueGene
#
#
# Sets the interval between recalculation of the SYSPRIO values.
# This must be done for Fair Share Scheduling to adjust job priorities 
# according to the most recent resource usage information.
# NEGOTIATOR_RECALCULATE_SYSPRIO_INTERVAL = 300
# 
#
#	Setup for Fair Share Scheduling - End
#


# Specifies if the central manager will check the existence of userids on the central manager node.
# The default value is True so the current environment of always checking will prevail.
#
# CM_CHECK_USERID=true
#
